// 
// The LibSea Graph Library.
// Copyright (C) 2000,2001,2002 The Regents of the University of California.
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
// ######END_HEADER######
// 


package org.caida.libsea;

public final class OptimizationType
{
    public static final int _FASTEST = 0;
    public static final int _SPACE_EFFICIENT = 1;
    public static final int _MINIMAL_SPACE = 2;

    public static final OptimizationType FASTEST =
	new OptimizationType(_FASTEST);
    public static final OptimizationType SPACE_EFFICIENT =
	new OptimizationType(_SPACE_EFFICIENT);
    public static final OptimizationType MINIMAL_SPACE =
	new OptimizationType(_MINIMAL_SPACE);

    public int getType()
    {
	return m_type;
    }

    public String getName()
    {
	return m_names[m_type];
    }

    private OptimizationType(int type)
    {
	m_type = type;
    }

    private final int  m_type;
    private static final String[]  m_names = 
    {
	"FASTEST", "SPACE_EFFICIENT", "MINIMAL_SPACE"
    };
}
